diff --git a/src/backend/commands/analyze.c b/src/backend/commands/analyze.c
index 9cd6e67..1ac9b5a 100644
--- a/src/backend/commands/analyze.c
+++ b/src/backend/commands/analyze.c
@@ -21,12 +21,15 @@
 #include "access/tuptoaster.h"
 #include "access/visibilitymap.h"
 #include "access/xact.h"
+#include "catalog/heap.h"
 #include "catalog/index.h"
 #include "catalog/indexing.h"
+#include "catalog/namespace.h"
 #include "catalog/pg_collation.h"
 #include "catalog/pg_inherits_fn.h"
 #include "catalog/pg_namespace.h"
 #include "commands/dbcommands.h"
+#include "commands/defrem.h"
 #include "commands/tablecmds.h"
 #include "commands/vacuum.h"
 #include "executor/executor.h"
@@ -42,7 +45,9 @@
 #include "storage/procarray.h"
 #include "utils/acl.h"
 #include "utils/attoptcache.h"
+#include "utils/builtins.h"
 #include "utils/datum.h"
+#include "utils/fmgroids.h"
 #include "utils/guc.h"
 #include "utils/lsyscache.h"
 #include "utils/memutils.h"
@@ -69,8 +74,10 @@ typedef struct AnlIndexData
 {
 	IndexInfo  *indexInfo;		/* BuildIndexInfo result */
 	double		tupleFract;		/* fraction of rows for partial index */
-	VacAttrStats **vacattrstats;	/* index attrs to analyze */
-	int			attr_cnt;
+	VacStats **vacstats;		/* index attrs to analyze */
+	int			stats_cnt;	/* this many stats we need to compute - single and cross-column stats included */
+	int			attr_cnt;	/* the relation has attr_cnt number of columns */
+	bool			has_xcol_stats;
 } AnlIndexData;
 
 
@@ -94,8 +101,8 @@ static void compute_index_stats(Relation onerel, double totalrows,
 					AnlIndexData *indexdata, int nindexes,
 					HeapTuple *rows, int numrows,
 					MemoryContext col_context);
-static VacAttrStats *examine_attribute(Relation onerel, int attnum,
-				  Node *index_expr);
+static VacStats *examine_attribute(Relation onerel, int2vector *attnums, bool inh,
+				  Node **index_expr);
 static int acquire_sample_rows(Relation onerel, HeapTuple *rows,
 					int targrows, double *totalrows, double *totaldeadrows);
 static double random_fract(void);
@@ -106,10 +113,16 @@ static int acquire_inherited_sample_rows(Relation onerel,
 							  HeapTuple *rows, int targrows,
 							  double *totalrows, double *totaldeadrows);
 static void update_attstats(Oid relid, bool inh,
-				int natts, VacAttrStats **vacattrstats);
-static Datum std_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull);
-static Datum ind_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull);
+				int natts, VacStats **vacstats);
+static Datum std_fetch_func(VacStatsP stats, int rownum, AttrNumber tupattnum,
+							  bool *isNull);
+static Datum ind_fetch_func(VacStatsP stats, int rownum, AttrNumber tupattnum,
+							  bool *isNull);
 
+static int ordered_findval(VacStatsP stats, int rownum, int index, AnalyzeAttrFetchFunc fetchfunc, void *arg);
+static int unordered_findval(VacStatsP stats, int rownum, int index, AnalyzeAttrFetchFunc fetchfunc, void *arg);
+static void compute_cross_column_stats(VacStatsP stats, AnalyzeAttrFetchFunc fetchfunc,
+							  int numrows);
 
 /*
  *	analyze_rel() -- analyze one relation
@@ -252,20 +265,78 @@ analyze_rel(Oid relid, VacuumStmt *vacstmt, BufferAccessStrategy bstrategy)
 	LWLockRelease(ProcArrayLock);
 }
 
+static int
+get_extrastats_count(Oid relid, int2vector ***out_attnumvectors)
+{
+	Relation	pgstatistic;
+	TupleDesc	tupDesc;
+	SysScanDesc	scan;
+	ScanKeyData	key;
+	HeapTuple	tuple;
+	int		count = 0;
+	bool		isnull;
+	int2vector *attnumvector = NULL;
+	int2vector **attnumvectors = NULL;
+
+	pgstatistic = heap_open(StatisticRelationId, RowExclusiveLock);
+	tupDesc = RelationGetDescr(pgstatistic);
+
+	ScanKeyInit(&key,
+				Anum_pg_statistic_starelid,
+				BTEqualStrategyNumber, F_OIDEQ,
+				ObjectIdGetDatum(relid));
+
+	scan = systable_beginscan(pgstatistic, StatisticRelidAttnumsInhIndexId, true,
+								SnapshotNow, 1, &key);
+
+	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
+	{
+		Datum	attnvec = heap_getattr(tuple, Anum_pg_statistic_staattnums, tupDesc, &isnull);
+
+		Assert(!isnull);
+
+		attnumvector = (int2vector *) DatumGetPointer(attnvec);
+
+		if (attnumvector->dim1 > 1)
+		{
+			count++;
+			if (out_attnumvectors)
+			{
+				if (attnumvectors == NULL)
+					attnumvectors = palloc(count * sizeof(int2vector *));
+				else
+					attnumvectors = repalloc(attnumvectors, count * sizeof(int2vector *));
+				attnumvectors[count - 1] = (int2vector *)datumCopy(attnvec, false, -1);
+			}
+		}
+	}
+
+	systable_endscan(scan);
+	                                                                                                  
+	heap_close(pgstatistic, RowExclusiveLock);
+
+	if (out_attnumvectors)
+		*out_attnumvectors = attnumvectors;
+
+	return count;
+}
+
 /*
  *	do_analyze_rel() -- analyze one relation, recursively or not
  */
 static void
 do_analyze_rel(Relation onerel, VacuumStmt *vacstmt, bool inh)
 {
-	int			attr_cnt,
+	int			stats_cnt,
+				extrastats_cnt,
 				tcnt,
 				i,
 				ind;
 	Relation   *Irel;
 	int			nindexes;
 	bool		hasindex;
-	VacAttrStats **vacattrstats;
+	VacStats **vacstats;
+	int2vector   **extrastats_attnums;
 	AnlIndexData *indexdata;
 	int			targrows,
 				numrows;
@@ -328,38 +399,75 @@ do_analyze_rel(Relation onerel, VacuumStmt *vacstmt, bool inh)
 	{
 		ListCell   *le;
 
-		vacattrstats = (VacAttrStats **) palloc(list_length(vacstmt->va_cols) *
-												sizeof(VacAttrStats *));
+		vacstats = (VacStats **) palloc(list_length(vacstmt->va_cols) *
+												sizeof(VacStats *));
 		tcnt = 0;
 		foreach(le, vacstmt->va_cols)
 		{
 			char	   *col = strVal(lfirst(le));
+			AttrNumber attnum;
+			int2vector *attnums;
 
-			i = attnameAttNum(onerel, col, false);
-			if (i == InvalidAttrNumber)
+			attnum = attnameAttNum(onerel, col, false);
+			if (attnum == InvalidAttrNumber)
 				ereport(ERROR,
 						(errcode(ERRCODE_UNDEFINED_COLUMN),
 					errmsg("column \"%s\" of relation \"%s\" does not exist",
 						   col, RelationGetRelationName(onerel))));
-			vacattrstats[tcnt] = examine_attribute(onerel, i, NULL);
-			if (vacattrstats[tcnt] != NULL)
+			attnums = buildint2vector(&attnum, 1);
+			vacstats[tcnt] = examine_attribute(onerel, attnums, inh, NULL);
+			if (vacstats[tcnt] != NULL)
 				tcnt++;
+			else
+				pfree(attnums);
 		}
-		attr_cnt = tcnt;
+		stats_cnt = tcnt;
+		extrastats_cnt = 0;
 	}
 	else
 	{
-		attr_cnt = onerel->rd_att->natts;
-		vacattrstats = (VacAttrStats **)
-			palloc(attr_cnt * sizeof(VacAttrStats *));
+		/*
+		 * Process all attributes of the relation unconditionally
+		 * as system tables may not have pg_statistic entries at
+		 * this point, they will be created in update_attstats().
+		 */
+		stats_cnt = onerel->rd_att->natts;
+
+		extrastats_cnt = get_extrastats_count(onerel->rd_id, &extrastats_attnums);
+
+		vacstats = (VacStats **)
+			palloc((stats_cnt + extrastats_cnt) * sizeof(VacStats *));
 		tcnt = 0;
-		for (i = 1; i <= attr_cnt; i++)
+		for (i = 1; i <= stats_cnt; i++)
 		{
-			vacattrstats[tcnt] = examine_attribute(onerel, i, NULL);
-			if (vacattrstats[tcnt] != NULL)
+			AttrNumber attnum = i;
+			int2vector *attnums;
+
+			attnums = buildint2vector(&attnum, 1);
+
+			vacstats[tcnt] = examine_attribute(onerel, attnums, inh, NULL);
+			if (vacstats[tcnt] != NULL)
 				tcnt++;
+			else
+				pfree(attnums);
 		}
-		attr_cnt = tcnt;
+
+		/* Now process the extra statistics */
+		if (extrastats_attnums)
+		{
+			for (i = 0; extrastats_attnums && i < extrastats_cnt; i++)
+			{
+				vacstats[tcnt] = examine_attribute(onerel, extrastats_attnums[i], inh, NULL);
+				if (vacstats[tcnt] != NULL)
+					tcnt++;
+				else
+					pfree(extrastats_attnums[i]);
+			}
+			pfree(extrastats_attnums);
+			extrastats_attnums = NULL;
+		}
+
+		stats_cnt = tcnt;
 	}
 
 	/*
@@ -388,13 +496,20 @@ do_analyze_rel(Relation onerel, VacuumStmt *vacstmt, bool inh)
 
 			thisdata->indexInfo = indexInfo = BuildIndexInfo(Irel[ind]);
 			thisdata->tupleFract = 1.0; /* fix later if partial */
+
+			tcnt = 0;
+			extrastats_cnt = get_extrastats_count(Irel[ind]->rd_id, &extrastats_attnums);
+
+			/*
+			 * Process expression index single-attribute statistics.
+			 */
 			if (indexInfo->ii_Expressions != NIL && vacstmt->va_cols == NIL)
 			{
 				ListCell   *indexpr_item = list_head(indexInfo->ii_Expressions);
 
-				thisdata->vacattrstats = (VacAttrStats **)
-					palloc(indexInfo->ii_NumIndexAttrs * sizeof(VacAttrStats *));
-				tcnt = 0;
+				thisdata->vacstats = (VacStats **)
+					palloc((indexInfo->ii_NumIndexAttrs + extrastats_cnt) * sizeof(VacStats *));
+
 				for (i = 0; i < indexInfo->ii_NumIndexAttrs; i++)
 				{
 					int			keycol = indexInfo->ii_KeyAttrNumbers[i];
@@ -403,19 +518,74 @@ do_analyze_rel(Relation onerel, VacuumStmt *vacstmt, bool inh)
 					{
 						/* Found an index expression */
 						Node	   *indexkey;
+						AttrNumber	attnum;
+						int2vector *attnums;
 
 						if (indexpr_item == NULL)		/* shouldn't happen */
 							elog(ERROR, "too few entries in indexprs list");
 						indexkey = (Node *) lfirst(indexpr_item);
 						indexpr_item = lnext(indexpr_item);
-						thisdata->vacattrstats[tcnt] =
-							examine_attribute(Irel[ind], i + 1, indexkey);
-						if (thisdata->vacattrstats[tcnt] != NULL)
+
+						attnum = i + 1;
+						attnums = buildint2vector(&attnum, 1);
+
+						thisdata->vacstats[tcnt] =
+							examine_attribute(Irel[ind], attnums, inh, &indexkey);
+						if (thisdata->vacstats[tcnt] != NULL)
 							tcnt++;
+						else
+							pfree(attnums);
 					}
 				}
-				thisdata->attr_cnt = tcnt;
+
 			}
+
+			/*
+			 * Process cross-column statistics. There can only be at most one
+			 * multi-column statistics for an index that covers every attributes.
+			 */
+			if (extrastats_attnums && vacstmt->va_cols == NIL)
+			{
+				Node	   *indexkeys[STATISTIC_NUM_SLOTS];
+
+				if (thisdata->vacstats == NULL)
+					thisdata->vacstats = (VacStats **) palloc(sizeof(VacStats *));
+
+				/*
+				 * Don't process indexes with too many attributes.
+				 * CREATE EXTRA STATISTICS bails out for such a case
+				 * but better safe than sorry.
+				 */
+				if (indexInfo->ii_NumIndexAttrs <= STATISTIC_NUM_SLOTS)
+				{
+					ListCell   *indexpr_item = list_head(indexInfo->ii_Expressions);
+
+					for (i = 0; i < indexInfo->ii_NumIndexAttrs; i++)
+					{
+						int	keycol = indexInfo->ii_KeyAttrNumbers[i];
+						if (keycol == 0)
+						{
+							indexkeys[i] = (Node *) lfirst(indexpr_item);
+							indexpr_item = lnext(indexpr_item);
+						}
+						else
+							indexkeys[i] = NULL;
+					}
+
+					thisdata->vacstats[tcnt] = examine_attribute(onerel, extrastats_attnums[0], inh, indexkeys);
+					if (thisdata->vacstats[tcnt] != NULL)
+						tcnt++;
+					else
+						pfree(extrastats_attnums[i]);
+				}
+				pfree(extrastats_attnums);
+				extrastats_attnums = NULL;
+
+				thisdata->has_xcol_stats = true;
+			}
+
+			thisdata->stats_cnt = tcnt;
+			thisdata->attr_cnt = indexInfo->ii_NumIndexAttrs;
 		}
 	}
 
@@ -426,19 +596,19 @@ do_analyze_rel(Relation onerel, VacuumStmt *vacstmt, bool inh)
 	 * the target in the corner case where there are no analyzable columns.)
 	 */
 	targrows = 100;
-	for (i = 0; i < attr_cnt; i++)
+	for (i = 0; i < stats_cnt; i++)
 	{
-		if (targrows < vacattrstats[i]->minrows)
-			targrows = vacattrstats[i]->minrows;
+		if (targrows < vacstats[i]->minrows)
+			targrows = vacstats[i]->minrows;
 	}
 	for (ind = 0; ind < nindexes; ind++)
 	{
 		AnlIndexData *thisdata = &indexdata[ind];
 
-		for (i = 0; i < thisdata->attr_cnt; i++)
+		for (i = 0; i < thisdata->stats_cnt; i++)
 		{
-			if (targrows < thisdata->vacattrstats[i]->minrows)
-				targrows = thisdata->vacattrstats[i]->minrows;
+			if (targrows < thisdata->vacstats[i]->minrows)
+				targrows = thisdata->vacstats[i]->minrows;
 		}
 	}
 
@@ -456,7 +626,7 @@ do_analyze_rel(Relation onerel, VacuumStmt *vacstmt, bool inh)
 	/*
 	 * Compute the statistics.	Temporary results during the calculations for
 	 * each column are stored in a child context.  The calc routines are
-	 * responsible to make sure that whatever they store into the VacAttrStats
+	 * responsible to make sure that whatever they store into the VacStats
 	 * structure is allocated in anl_context.
 	 */
 	if (numrows > 0)
@@ -471,33 +641,40 @@ do_analyze_rel(Relation onerel, VacuumStmt *vacstmt, bool inh)
 											ALLOCSET_DEFAULT_MAXSIZE);
 		old_context = MemoryContextSwitchTo(col_context);
 
-		for (i = 0; i < attr_cnt; i++)
+		for (i = 0; i < stats_cnt; i++)
 		{
-			VacAttrStats *stats = vacattrstats[i];
+			VacStats *stats = vacstats[i];
 			AttributeOpts *aopt;
+			int		j;
 
 			stats->rows = rows;
 			stats->tupDesc = onerel->rd_att;
-			(*stats->compute_stats) (stats,
+
+			for (j = 0; j < stats->attnums->dim1; j++)
+			{
+				(*stats->statfuncs[j].compute_func_ptr) (stats,
+									 j, 
 									 std_fetch_func,
 									 numrows,
 									 totalrows);
+				/*
+				 * If the appropriate flavor of the n_distinct option is
+				 * specified, override with the corresponding value.
+				 */
+				aopt = get_attribute_options(onerel->rd_id, stats->attnums->values[j]);
+				if (aopt != NULL)
+				{
+					float8		n_distinct =
+					inh ? aopt->n_distinct_inherited : aopt->n_distinct;
 
-			/*
-			 * If the appropriate flavor of the n_distinct option is
-			 * specified, override with the corresponding value.
-			 */
-			aopt = get_attribute_options(onerel->rd_id, stats->attr->attnum);
-			if (aopt != NULL)
-			{
-				float8		n_distinct;
-
-				n_distinct = inh ? aopt->n_distinct_inherited : aopt->n_distinct;
-				if (n_distinct != 0.0)
-					stats->stadistinct = n_distinct;
+					if (n_distinct != 0.0)
+						stats->stadistinct[j] = n_distinct;
+				}
 			}
 
 			MemoryContextResetAndDeleteChildren(col_context);
+
+			compute_cross_column_stats(stats, std_fetch_func, numrows);
 		}
 
 		if (hasindex)
@@ -515,14 +692,17 @@ do_analyze_rel(Relation onerel, VacuumStmt *vacstmt, bool inh)
 		 * pg_statistic for columns we didn't process, we leave them alone.)
 		 */
 		update_attstats(RelationGetRelid(onerel), inh,
-						attr_cnt, vacattrstats);
+						stats_cnt, vacstats);
 
 		for (ind = 0; ind < nindexes; ind++)
 		{
 			AnlIndexData *thisdata = &indexdata[ind];
 
+			for (i = 0; i < thisdata->stats_cnt; i++)
+				compute_cross_column_stats(thisdata->vacstats[i], ind_fetch_func, numrows);
+
 			update_attstats(RelationGetRelid(Irel[ind]), false,
-							thisdata->attr_cnt, thisdata->vacattrstats);
+							thisdata->stats_cnt, thisdata->vacstats);
 		}
 	}
 
@@ -632,6 +812,8 @@ compute_index_stats(Relation onerel, double totalrows,
 				old_context;
 	Datum		values[INDEX_MAX_KEYS];
 	bool		isnull[INDEX_MAX_KEYS];
+	bool		typbyval[INDEX_MAX_KEYS];
+	int16		typlen[INDEX_MAX_KEYS];
 	int			ind,
 				i;
 
@@ -646,7 +828,7 @@ compute_index_stats(Relation onerel, double totalrows,
 	{
 		AnlIndexData *thisdata = &indexdata[ind];
 		IndexInfo  *indexInfo = thisdata->indexInfo;
-		int			attr_cnt = thisdata->attr_cnt;
+		int			stats_cnt = thisdata->stats_cnt;
 		TupleTableSlot *slot;
 		EState	   *estate;
 		ExprContext *econtext;
@@ -657,11 +839,30 @@ compute_index_stats(Relation onerel, double totalrows,
 					tcnt,
 					rowno;
 		double		totalindexrows;
+		ListCell   *indexpr_item = list_head(indexInfo->ii_Expressions);
 
 		/* Ignore index if no columns to analyze and not partial */
-		if (attr_cnt == 0 && indexInfo->ii_Predicate == NIL)
+		if (stats_cnt == 0 && indexInfo->ii_Predicate == NIL)
 			continue;
 
+		for (i = 0; i < thisdata->attr_cnt; i++)
+		{
+			int	keycol = indexInfo->ii_KeyAttrNumbers[i];
+
+			if (keycol == 0)
+			{
+				Node *indexkey = (Node *) lfirst(indexpr_item);
+
+				get_typlenbyval(exprType(indexkey), &typlen[i], &typbyval[i]);
+				indexpr_item = lnext(indexpr_item);
+			}
+			else
+			{
+				typbyval[i] = onerel->rd_att->attrs[keycol - 1]->attbyval;
+				typlen[i] = onerel->rd_att->attrs[keycol - 1]->attlen;
+			}
+		}
+
 		/*
 		 * Need an EState for evaluation of index expressions and
 		 * partial-index predicates.  Create it in the per-index context to be
@@ -681,8 +882,8 @@ compute_index_stats(Relation onerel, double totalrows,
 							estate);
 
 		/* Compute and save index expression values */
-		exprvals = (Datum *) palloc(numrows * attr_cnt * sizeof(Datum));
-		exprnulls = (bool *) palloc(numrows * attr_cnt * sizeof(bool));
+		exprvals = (Datum *) palloc(numrows * thisdata->attr_cnt * sizeof(Datum));
+		exprnulls = (bool *) palloc(numrows * thisdata->attr_cnt * sizeof(bool));
 		numindexrows = 0;
 		tcnt = 0;
 		for (rowno = 0; rowno < numrows; rowno++)
@@ -706,7 +907,7 @@ compute_index_stats(Relation onerel, double totalrows,
 			}
 			numindexrows++;
 
-			if (attr_cnt > 0)
+			if (stats_cnt > 0)
 			{
 				/*
 				 * Evaluate the index row to compute expression values. We
@@ -719,24 +920,18 @@ compute_index_stats(Relation onerel, double totalrows,
 							   isnull);
 
 				/*
-				 * Save just the columns we care about.  We copy the values
-				 * into ind_context from the estate's per-tuple context.
+				 * We copy the values * into ind_context from the estate's per-tuple context.
 				 */
-				for (i = 0; i < attr_cnt; i++)
+				for (i = 0; i < thisdata->attr_cnt; i++)
 				{
-					VacAttrStats *stats = thisdata->vacattrstats[i];
-					int			attnum = stats->attr->attnum;
-
-					if (isnull[attnum - 1])
+					if (isnull[i])
 					{
 						exprvals[tcnt] = (Datum) 0;
 						exprnulls[tcnt] = true;
 					}
 					else
 					{
-						exprvals[tcnt] = datumCopy(values[attnum - 1],
-												   stats->attrtype->typbyval,
-												   stats->attrtype->typlen);
+						exprvals[tcnt] = datumCopy(values[i], typbyval[i], typlen[i]);
 						exprnulls[tcnt] = false;
 					}
 					tcnt++;
@@ -757,28 +952,37 @@ compute_index_stats(Relation onerel, double totalrows,
 		if (numindexrows > 0)
 		{
 			MemoryContextSwitchTo(col_context);
-			for (i = 0; i < attr_cnt; i++)
+			for (i = 0; i < stats_cnt; i++)
 			{
-				VacAttrStats *stats = thisdata->vacattrstats[i];
-				AttributeOpts *aopt =
-				get_attribute_options(stats->attr->attrelid,
-									  stats->attr->attnum);
-
-				stats->exprvals = exprvals + i;
-				stats->exprnulls = exprnulls + i;
-				stats->rowstride = attr_cnt;
-				(*stats->compute_stats) (stats,
-										 ind_fetch_func,
-										 numindexrows,
-										 totalindexrows);
+				VacStats *stats = thisdata->vacstats[i];
+				AttributeOpts *aopt;
+				int		j;
 
-				/*
-				 * If the n_distinct option is specified, it overrides the
-				 * above computation.  For indices, we always use just
-				 * n_distinct, not n_distinct_inherited.
-				 */
-				if (aopt != NULL && aopt->n_distinct != 0.0)
-					stats->stadistinct = aopt->n_distinct;
+				for (j = 0; j < stats->attnums->dim1; j++)
+				{
+					if (stats->attnums->dim1 == 1)
+						aopt = get_attribute_options(stats->attrs[j]->attrelid,
+										  stats->attrs[j]->attnum);
+					else
+						aopt = NULL;
+
+					stats->exprvals = exprvals;
+					stats->exprnulls = exprnulls;
+					stats->rowstride = thisdata->attr_cnt;
+					(*stats->statfuncs[j].compute_func_ptr) (stats,
+											 j,
+											 ind_fetch_func,
+											 numindexrows,
+											 totalindexrows);
+
+					/*
+					 * If the n_distinct option is specified, it overrides the
+					 * above computation.  For indices, we always use just
+					 * n_distinct, not n_distinct_inherited.
+					 */
+					if (aopt != NULL && aopt->n_distinct != 0.0)
+						stats->stadistinct[j] = aopt->n_distinct;
+				}
 
 				MemoryContextResetAndDeleteChildren(col_context);
 			}
@@ -797,38 +1001,77 @@ compute_index_stats(Relation onerel, double totalrows,
 }
 
 /*
- * examine_attribute -- pre-analysis of a single column
+ * statistics_target -- returns pg_statistic.statarget
+ */
+static int4
+statistics_target(Oid relid, int2vector *attnums, bool inherited)
+{
+	HeapTuple		tuple;
+	int4			statarget = -1; /* default */
+
+	tuple = SearchSysCache3(STATRELATTINH,
+								ObjectIdGetDatum(relid),
+								PointerGetDatum(attnums),
+								BoolGetDatum(inherited));
+	if (HeapTupleIsValid(tuple))
+	{
+		Form_pg_statistic stats = (Form_pg_statistic) GETSTRUCT(tuple);
+
+		statarget = stats->statarget;
+
+		ReleaseSysCache(tuple);
+	}
+
+	return statarget;
+}
+
+
+/*
+ * examine_attribute -- pre-analysis of a single column or a set of columns
  *
  * Determine whether the column is analyzable; if so, create and initialize
- * a VacAttrStats struct for it.  If not, return NULL.
+ * a VacStats struct for it.  If not, return NULL.
  *
  * If index_expr isn't NULL, then we're trying to analyze an expression index,
  * and index_expr is the expression tree representing the column's data.
  */
-static VacAttrStats *
-examine_attribute(Relation onerel, int attnum, Node *index_expr)
+static VacStats *
+examine_attribute(Relation onerel, int2vector *attnums, bool inh, Node **index_exprs)
 {
-	Form_pg_attribute attr = onerel->rd_att->attrs[attnum - 1];
 	HeapTuple	typtuple;
-	VacAttrStats *stats;
-	int			i;
+	int4		statarget;
+	VacStats *stats;
+	int			i, j;
 	bool		ok;
 
-	/* Never analyze dropped columns */
-	if (attr->attisdropped)
-		return NULL;
+	for (i = 0; i < attnums->dim1; i++)
+	{
+		Form_pg_attribute attr = onerel->rd_att->attrs[attnums->values[i] - 1];
+
+		/* Never analyze dropped columns */
+		if (attr->attisdropped)
+			return NULL;
+	}
 
 	/* Don't analyze column if user has specified not to */
-	if (attr->attstattarget == 0)
+	statarget = statistics_target(onerel->rd_id, attnums, inh);
+	if (statarget == 0)
 		return NULL;
 
 	/*
-	 * Create the VacAttrStats struct.	Note that we only have a copy of the
+	 * Create the VacStats struct.	Note that we only have a copy of the
 	 * fixed fields of the pg_attribute tuple.
 	 */
-	stats = (VacAttrStats *) palloc0(sizeof(VacAttrStats));
-	stats->attr = (Form_pg_attribute) palloc(ATTRIBUTE_FIXED_PART_SIZE);
-	memcpy(stats->attr, attr, ATTRIBUTE_FIXED_PART_SIZE);
+	stats = (VacStats *) palloc0(sizeof(VacStats));
+	for (i = 0; i < attnums->dim1; i++)
+	{
+		Form_pg_attribute attr = onerel->rd_att->attrs[attnums->values[i] - 1];
+		stats->attrs[i] = (Form_pg_attribute) palloc(ATTRIBUTE_FIXED_PART_SIZE);
+		memcpy(stats->attrs[i], attr, ATTRIBUTE_FIXED_PART_SIZE);
+	}
+
+	stats->attnums = attnums;
+	stats->statarget = statarget;
 
 	/*
 	 * When analyzing an expression index, believe the expression tree's type
@@ -839,54 +1082,86 @@ examine_attribute(Relation onerel, int attnum, Node *index_expr)
 	 * not a problem.)	It's not clear whether anyone will care about the
 	 * typmod, but we store that too just in case.
 	 */
-	if (index_expr)
-	{
-		stats->attrtypid = exprType(index_expr);
-		stats->attrtypmod = exprTypmod(index_expr);
-	}
-	else
+
+	for (i = 0; i < attnums->dim1; i++)
 	{
-		stats->attrtypid = attr->atttypid;
-		stats->attrtypmod = attr->atttypmod;
+		if (index_exprs && index_exprs[i])
+		{
+			stats->attrtypids[i] = exprType(index_exprs[i]);
+			stats->attrtypmods[i] = exprTypmod(index_exprs[i]);
+		}
+		else
+		{
+			stats->attrtypids[i] = stats->attrs[i]->atttypid;
+			stats->attrtypmods[i] = stats->attrs[i]->atttypmod;
+		}
+
+		typtuple = SearchSysCacheCopy1(TYPEOID,
+									   ObjectIdGetDatum(stats->attrtypids[i]));
+		if (!HeapTupleIsValid(typtuple))
+			elog(ERROR, "cache lookup failed for type %u", stats->attrtypids[i]);
+		stats->attrtypes[i] = (Form_pg_type) GETSTRUCT(typtuple);
 	}
 
-	typtuple = SearchSysCacheCopy1(TYPEOID,
-								   ObjectIdGetDatum(stats->attrtypid));
-	if (!HeapTupleIsValid(typtuple))
-		elog(ERROR, "cache lookup failed for type %u", stats->attrtypid);
-	stats->attrtype = (Form_pg_type) GETSTRUCT(typtuple);
 	stats->anl_context = anl_context;
-	stats->tupattnum = attnum;
 
 	/*
 	 * The fields describing the stats->stavalues[n] element types default to
 	 * the type of the data being analyzed, but the type-specific typanalyze
 	 * function can change them if it wants to store something else.
 	 */
-	for (i = 0; i < STATISTIC_NUM_SLOTS; i++)
+	for (i = 0; i < attnums->dim1; i++)
 	{
-		stats->statypid[i] = stats->attrtypid;
-		stats->statyplen[i] = stats->attrtype->typlen;
-		stats->statypbyval[i] = stats->attrtype->typbyval;
-		stats->statypalign[i] = stats->attrtype->typalign;
+		for (j = 0; j < STATISTIC_NUM_SLOTS; j++)
+		{
+			stats->statypid[i][j] = stats->attrtypids[i];
+			stats->statyplen[i][j] = stats->attrtypes[i]->typlen;
+			stats->statypbyval[i][j] = stats->attrtypes[i]->typbyval;
+			stats->statypalign[i][j] = stats->attrtypes[i]->typalign;
+		}
+
+		/*
+		 * Call the type-specific typanalyze function.	If none is specified, use
+		 * std_typanalyze().
+		 */
+		if (OidIsValid(stats->attrtypes[i]->typanalyze))
+			ok = DatumGetBool(OidFunctionCall2(stats->attrtypes[i]->typanalyze,
+										   PointerGetDatum(stats),
+										   Int32GetDatum(i)));
+		else
+			ok = std_typanalyze(stats, i);
+
+		if (!ok ||
+			stats->statfuncs[i].compute_func_ptr == NULL ||
+			/* intentionally don't check stats->statfuncs[i].findval_func_ptr == NULL */
+			stats->minrows <= 0)
+		{
+			for (; i >= 0; i--)
+			{
+				heap_freetuple((HeapTuple) stats->attrtypes[i]);
+				pfree(stats->attrs[i]);
+			}
+			pfree(stats);
+
+			return NULL;
+		}
 	}
 
 	/*
-	 * Call the type-specific typanalyze function.	If none is specified, use
-	 * std_typanalyze().
+	 * If we have a cross-column statistics, compute the cube size for
+	 * the histogram so pg_statistic.statarget really means the number of
+	 * cells in the multi-dimensional cube.
 	 */
-	if (OidIsValid(stats->attrtype->typanalyze))
-		ok = DatumGetBool(OidFunctionCall1(stats->attrtype->typanalyze,
-										   PointerGetDatum(stats)));
-	else
-		ok = std_typanalyze(stats);
-
-	if (!ok || stats->compute_stats == NULL || stats->minrows <= 0)
+	if (stats->attnums->dim1 > 1)
 	{
-		heap_freetuple(typtuple);
-		pfree(stats->attr);
-		pfree(stats);
-		return NULL;
+		double		x, y, n;
+
+		y = stats->statarget;
+		n = stats->attnums->dim1;
+		x = pow(M_E, (log(y) / n));
+
+		/* On some systems, ceil() returns surprising result. */
+		stats->statarget = trunc(x + 0.5);
 	}
 
 	return stats;
@@ -1560,7 +1835,7 @@ acquire_inherited_sample_rows(Relation onerel, HeapTuple *rows, int targrows,
  *		by taking a self-exclusive lock on the relation in analyze_rel().
  */
 static void
-update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
+update_attstats(Oid relid, bool inh, int natts, VacStats **vacstats)
 {
 	Relation	sd;
 	int			attno;
@@ -1572,7 +1847,7 @@ update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
 
 	for (attno = 0; attno < natts; attno++)
 	{
-		VacAttrStats *stats = vacattrstats[attno];
+		VacStats *stats = vacstats[attno];
 		HeapTuple	stup,
 					oldtup;
 		int			i,
@@ -1595,26 +1870,35 @@ update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
 			replaces[i] = true;
 		}
 
+		/*
+		 * We use statarget = -1 here, so if the pg_statistic entry is new,
+		 * we use the default_statistics_target for it. If there's a pg_statistic
+		 * row for this statistics, we will set the "replaces" flag to false.
+		 */
+		values[Anum_pg_statistic_statarget - 1] = Int32GetDatum(-1);
 		values[Anum_pg_statistic_starelid - 1] = ObjectIdGetDatum(relid);
-		values[Anum_pg_statistic_staattnum - 1] = Int16GetDatum(stats->attr->attnum);
 		values[Anum_pg_statistic_stainherit - 1] = BoolGetDatum(inh);
-		values[Anum_pg_statistic_stanullfrac - 1] = Float4GetDatum(stats->stanullfrac);
-		values[Anum_pg_statistic_stawidth - 1] = Int32GetDatum(stats->stawidth);
-		values[Anum_pg_statistic_stadistinct - 1] = Float4GetDatum(stats->stadistinct);
+		values[Anum_pg_statistic_stavalid - 1] = BoolGetDatum(true);
+		values[Anum_pg_statistic_stanullfrac - 1] = Float4GetDatum(stats->stanullfrac[0]);
+		values[Anum_pg_statistic_stawidth - 1] = Int32GetDatum(stats->stawidth[0]);
+		values[Anum_pg_statistic_stadistinct - 1] = Float4GetDatum(stats->stadistinct[0]);
 		i = Anum_pg_statistic_stakind1 - 1;
 		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
 		{
-			values[i++] = Int16GetDatum(stats->stakind[k]);		/* stakindN */
+			values[i++] = Int16GetDatum(stats->stakind[0][k]);	/* stakindN */
 		}
 		i = Anum_pg_statistic_staop1 - 1;
 		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
 		{
-			values[i++] = ObjectIdGetDatum(stats->staop[k]);	/* staopN */
+			values[i++] = ObjectIdGetDatum(stats->staop[0][k]);	/* staopN */
 		}
+
+		values[Anum_pg_statistic_staattnums - 1] = PointerGetDatum(stats->attnums);	/* staattnums */
+
 		i = Anum_pg_statistic_stanumbers1 - 1;
 		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
 		{
-			int			nnum = stats->numnumbers[k];
+			int			nnum = stats->numnumbers[0][k];
 
 			if (nnum > 0)
 			{
@@ -1622,7 +1906,7 @@ update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
 				ArrayType  *arry;
 
 				for (n = 0; n < nnum; n++)
-					numdatums[n] = Float4GetDatum(stats->stanumbers[k][n]);
+					numdatums[n] = Float4GetDatum(stats->stanumbers[0][k][n]);
 				/* XXX knows more than it should about type float4: */
 				arry = construct_array(numdatums, nnum,
 									   FLOAT4OID,
@@ -1638,16 +1922,29 @@ update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
 		i = Anum_pg_statistic_stavalues1 - 1;
 		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
 		{
-			if (stats->numvalues[k] > 0)
+			int	idx1, idx2;
+
+			if (stats->attnums->dim1 > 1 && k < stats->attnums->dim1)
+			{
+				idx1 = k;
+				idx2 = 0;
+			}
+			else
+			{
+				idx1 = 0;
+				idx2 = k;
+			}
+
+			if (stats->numvalues[idx1][idx2] > 0)
 			{
 				ArrayType  *arry;
 
-				arry = construct_array(stats->stavalues[k],
-									   stats->numvalues[k],
-									   stats->statypid[k],
-									   stats->statyplen[k],
-									   stats->statypbyval[k],
-									   stats->statypalign[k]);
+				arry = construct_array(stats->stavalues[idx1][idx2],
+									   stats->numvalues[idx1][idx2],
+									   stats->statypid[idx1][idx2],
+									   stats->statyplen[idx1][idx2],
+									   stats->statypbyval[idx1][idx2],
+									   stats->statypalign[idx1][idx2]);
 				values[i++] = PointerGetDatum(arry);	/* stavaluesN */
 			}
 			else
@@ -1660,11 +1957,14 @@ update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
 		/* Is there already a pg_statistic tuple for this attribute? */
 		oldtup = SearchSysCache3(STATRELATTINH,
 								 ObjectIdGetDatum(relid),
-								 Int16GetDatum(stats->attr->attnum),
+								 PointerGetDatum(stats->attnums),
 								 BoolGetDatum(inh));
 
 		if (HeapTupleIsValid(oldtup))
 		{
+			/* Skip replacing the statarget value, so we remember its value. */
+			replaces[Anum_pg_statistic_statarget - 1] = false;
+
 			/* Yes, replace it */
 			stup = heap_modify_tuple(oldtup,
 									 RelationGetDescr(sd),
@@ -1697,13 +1997,12 @@ update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
  * and the actual storage of the sample data.
  */
 static Datum
-std_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull)
+std_fetch_func(VacStatsP stats, int rownum, AttrNumber tupattnum, bool *isNull)
 {
-	int			attnum = stats->tupattnum;
 	HeapTuple	tuple = stats->rows[rownum];
 	TupleDesc	tupDesc = stats->tupDesc;
 
-	return heap_getattr(tuple, attnum, tupDesc, isNull);
+	return heap_getattr(tuple, tupattnum, tupDesc, isNull);
 }
 
 /*
@@ -1713,12 +2012,11 @@ std_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull)
  * just in Datum arrays.
  */
 static Datum
-ind_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull)
+ind_fetch_func(VacStatsP stats, int rownum, AttrNumber tupattnum, bool *isNull)
 {
 	int			i;
 
-	/* exprvals and exprnulls are already offset for proper column */
-	i = rownum * stats->rowstride;
+	i = rownum * stats->rowstride + tupattnum - 1;
 	*isNull = stats->exprnulls[i];
 	return stats->exprvals[i];
 }
